<template>
	<v-card class="FieldsTable">
		<div class="text-center py-6" v-if="isLoading">
			<v-progress-circular :size="50" color="primary" indeterminate></v-progress-circular>
		</div>
		<v-card-text v-else-if="hasError">There was an error loading resources. Please refresh.</v-card-text>
		<v-card-text v-else-if="!hasAccessToFields">You do not have access to any fields yet.</v-card-text>
		<v-card-text v-else-if="hasAccessToFields && fieldRows.length === 0"
			>No fields match your filters. Try clearing some of your filters to see results.</v-card-text
		>
		<div v-else class="FieldsTable-table">
			<template>
				<div v-for="column of tableHeaders" :key="column.key" class="FieldsTable-tableHeaderCell">
					{{ column.text }}
					<v-icon
						v-if="column.sortable"
						@click="handleSort(column.key)"
						:color="getIconConfig(column.key).color"
						dense
						>{{ getIconConfig(column.key).icon }}</v-icon
					>
				</div>
				<template v-for="fieldRow of fieldRows">
					<component
						v-for="column of tableHeaders"
						class="FieldsTable-tableCell"
						:key="`${column.key}-${fieldRow.id}`"
						:is="tableCellComponents[column.key].component"
						v-bind="tableCellComponents[column.key].getProps(fieldRow)"
					></component>
				</template>
			</template>
		</div>
	</v-card>
</template>

<script lang="ts">
import { defineComponent, computed } from '@vue/composition-api';
import { useAllResources } from '@/store/modules/resources';
import { useGroups } from '@/store/modules/group';
import { tableHeaders, tableCellComponents } from '@/store/modules/fieldsView/configuration';
import { SortDirOptions } from '@/store/modules/fieldsView/index';
import FieldsViewControls from '../FieldsViewControls/FieldsViewControls.vue';
import FieldStatusCell from './FieldStatusCell.vue';
import TextCell from './TextCell.vue';
import OfflineMapButton from '@/components/map/OfflineMapButton.vue';

export default defineComponent({
	components: {
		FieldsViewControls,
		FieldStatusCell,
		TextCell,
		OfflineMapButton,
	},
	setup(_, { root }) {
		const { isLoaded: areGroupsLoaded, isLoading: areGroupsLoading, hasError: groupsHaveError } = useGroups(
			root.$store
		);
		const {
			isLoaded: areResourcesLoaded,
			isLoading: areResourcesLoading,
			hasError: resourcesHaveError,
			fields,
		} = useAllResources(root.$store);
		const isLoaded = computed(() => areGroupsLoaded.value && areResourcesLoaded.value);
		const isLoading = computed(() => areGroupsLoading.value || areResourcesLoading.value);
		const hasError = computed(() => groupsHaveError.value || resourcesHaveError.value);
		const fieldRows = computed(() => root.$store.getters['fieldsView/getFieldRows']);
		const sortBy = computed(() => root.$store.getters['fieldsView/getSortBy']);
		const sortDir = computed(() => root.$store.getters['fieldsView/getSortDir']);

		const getIconConfig = (key: any) => {
			if (sortBy.value !== key) {
				return {
					icon: 'mdi-arrow-down',
					color: 'grey lighten-1',
				};
			} else {
				return {
					color: 'grey darken-3',
					icon: sortDir.value === 'ASC' ? 'mdi-arrow-up' : 'mdi-arrow-down',
				};
			}
		};

		const getNextSortDir = (sortDir: SortDirOptions) => {
			switch (sortDir) {
				case 'DESC':
					return 'ASC';
				case 'ASC':
					return null;
				case null:
				default:
					return 'DESC';
			}
		};

		const handleSort = (key: string) => {
			if (sortBy.value !== key) {
				root.$store.dispatch('fieldsView/changeSort', { sortBy: key, sortDir: 'DESC' });
			} else {
				const nextSortDir = getNextSortDir(sortDir.value);
				root.$store.dispatch('fieldsView/changeSort', {
					sortBy: nextSortDir === null ? null : key,
					sortDir: nextSortDir,
				});
			}
		};

		const hasAccessToFields = computed(() => isLoaded.value && fields.value.length > 0);

		return {
			isLoading,
			isLoaded,
			hasError,
			sortBy,
			sortDir,
			getNextSortDir,
			handleSort,
			fieldRows,
			tableHeaders: Object.values(tableHeaders),
			tableCellComponents,
			hasAccessToFields,
			getIconConfig,
		};
	},
});
</script>

<style>
.FieldsTable {
	height: 100%;
	overflow-y: auto;
}

.FieldsTable-table {
	display: grid;
	grid-template-columns: repeat(4, auto) min-content;
	row-gap: 4px;
	padding: 0px 16px 12px 16px;
}

.FieldsTable .FieldsTable-tableHeaderCell {
	display: flex;
	align-items: center;
	height: 60px;
	font-weight: 500;
	border-bottom: 2px solid #ccc;
	position: sticky;
	top: 0;
	z-index: 1;
	padding-top: 12px;
	background: #fff;
}

.FieldsTable-tableCell:nth-last-child(-n + 5) {
	border-bottom: none;
}

.FieldsTable-tableCell {
	border-bottom: 1px solid #ccc;
	padding: 2px;
}
</style>
